--[[local orig_BlackMarketManager_outfit_string_mask = BlackMarketManager._outfit_string_mask

function BlackMarketManager:_outfit_string_mask(spoof)
    if spoof then
    	local s = ""
    	local equipped = clone(managers.blackmarket:equipped_mask())
        local mask_id = type(equipped) == "string" and equipped or equipped.mask_id
        if tweak_data.blackmarket.masks[mask_id] and tweak_data.blackmarket.masks[mask_id].custom then
            equipped.mask_id = "character_locked"
        end

    	if type(equipped) == "string" then
    		s = s .. " " .. mask_id
    		s = s .. " " .. "nothing"
    		s = s .. " " .. "no_color_no_material"
    		s = s .. " " .. "plastic"
    	else
    		s = s .. " " .. equipped.mask_id
    		s = s .. " " .. equipped.blueprint.color.id
    		s = s .. " " .. equipped.blueprint.pattern.id
    		s = s .. " " .. equipped.blueprint.material.id
    	end
    	return s
    else
        return orig_BlackMarketManager_outfit_string_mask(self)
    end
end

local orig_BlackMarketManager_outfit_string = BlackMarketManager.outfit_string

function BlackMarketManager:outfit_string(real)
    if real then
        return orig_BlackMarketManager_outfit_string(self)
    else
    	local s = ""
    	s = s .. self:_outfit_string_mask(true)
    	local armor_id = tostring(self:equipped_armor(false))
    	local current_armor_id = tostring(self:equipped_armor(true))
    	local current_state_armor_id = tostring(self:equipped_armor(true, true))
    	s = s .. " " .. armor_id .. "-" .. current_armor_id .. "-" .. current_state_armor_id
    	for character_id, data in pairs(tweak_data.blackmarket.characters) do
    		if Global.blackmarket_manager.characters[character_id].equipped then
    			s = s .. " " .. character_id
    		end
    	end
    	local equipped_primary = self:equipped_primary()
    	if equipped_primary then
    		local primary_string = managers.weapon_factory:blueprint_to_string(equipped_primary.factory_id, equipped_primary.blueprint, true)
    		primary_string = string.gsub(primary_string, " ", "_")
            local fac_id = equipped_primary.factory_id
            if tweak_data.weapon.factory[fac_id].custom then
                fac_id = "wpn_fps_ass_amcar"
            end
    		s = s .. " " .. fac_id .. " " .. primary_string
    	else
    		s = s .. " " .. "nil" .. " " .. "0"
    	end
    	local equipped_secondary = self:equipped_secondary()
    	if equipped_secondary then
    		local secondary_string = managers.weapon_factory:blueprint_to_string(equipped_secondary.factory_id, equipped_secondary.blueprint, true)
    		secondary_string = string.gsub(secondary_string, " ", "_")
            local fac_id = equipped_secondary.factory_id
            if tweak_data.weapon.factory[fac_id].custom then
                fac_id = "wpn_fps_pis_g17"
            end
    		s = s .. " " .. fac_id .. " " .. secondary_string
    	else
    		s = s .. " " .. "nil" .. " " .. "0"
    	end
    	local equipped_deployable = self:equipped_deployable()
    	if equipped_deployable then
    		s = s .. " " .. tostring(equipped_deployable)
    		local deployable_tweak_data = tweak_data.equipments[equipped_deployable]
    		local amount = (deployable_tweak_data.quantity[1] or 0) + managers.player:equiptment_upgrade_value(equipped_deployable, "quantity")
    		s = s .. " " .. tostring(amount)
    	else
    		s = s .. " " .. "nil" .. " " .. "0"
    	end
    	local concealment_modifier = -self:visibility_modifiers() or 0
    	s = s .. " " .. tostring(concealment_modifier)
    	local equipped_melee_weapon = self:equipped_melee_weapon()
        if tweak_data.blackmarket.melee_weapons[equipped_melee_weapon].custom then
            equipped_melee_weapon = "weapon"
        end

    	s = s .. " " .. tostring(equipped_melee_weapon)
    	local equipped_grenade = self:equipped_grenade()
        if tweak_data.blackmarket.projectiles[equipped_grenade].custom then
            equipped_grenade = "frag_com"
        end

    	s = s .. " " .. tostring(equipped_grenade)
    	s = s .. " " .. tostring(managers.skilltree:pack_to_string())
    	if equipped_primary and equipped_primary.cosmetics then
    		local entry = tostring(equipped_primary.cosmetics.id)
    		local quality = tostring(tweak_data.economy:get_index_from_entry("qualities", equipped_primary.cosmetics.quality) or 1)
    		local bonus = equipped_primary.cosmetics.bonus and "1" or "0"
    		s = s .. " " .. entry .. "-" .. quality .. "-" .. bonus
    	else
    		s = s .. " " .. "nil-1-0"
    	end
    	if equipped_secondary and equipped_secondary.cosmetics then
    		local entry = tostring(equipped_secondary.cosmetics.id)
    		local quality = tostring(tweak_data.economy:get_index_from_entry("qualities", equipped_secondary.cosmetics.quality) or 1)
    		local bonus = equipped_secondary.cosmetics.bonus and "1" or "0"
    		s = s .. " " .. entry .. "-" .. quality .. "-" .. bonus
    	else
    		s = s .. " " .. "nil-1-0"
    	end
    	return s
    end
end]]--
