_G.BB = _G.BB or {}
BB._path = ModPath
BB._data_path = SavePath .. "bb_data.txt"
BB._data = {}
BB.cops_to_intimidate = {}
BB.grace_period = 10

function BB:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function BB:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_BB", function(loc)
	for _, filename in pairs(file.GetFiles(BB._path .. "loc/")) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			loc:load_localization_file(BB._path .. "loc/" .. filename)
			break
		end
	end
	loc:load_localization_file(BB._path .. "loc/english.txt", false)
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_BB", function( menu_manager )
	MenuCallbackHandler.callback_number_choice = function(self, item)
		BB._data.number = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_health_choice = function(self, item)
		BB._data.health = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_speed_choice = function(self, item)
		BB._data.speed = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_move_choice = function(self, item)
		BB._data.move = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_dodge_choice = function(self, item)
		BB._data.dodge = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_weaprof_choice = function(self, item)
		BB._data.weaprof = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_weap_choice = function(self, item)
		BB._data.weap = item:value()
		BB:Save()
	end
	MenuCallbackHandler.callback_dmg_toggle = function(self, item)
		BB._data.mindmg = (item:value() == "on" and true or false)
		BB:Save()
	end
	MenuCallbackHandler.callback_dwn_toggle = function(self, item)
		BB._data.instadwn = (item:value() == "on" and true or false)
		BB:Save()
	end
	MenuCallbackHandler.callback_clk_toggle = function(self, item)
		BB._data.clkarrest = (item:value() == "on" and true or false)
		BB:Save()
	end
	MenuCallbackHandler.callback_chat_toggle = function(self, item)
		BB._data.chat = (item:value() == "on" and true or false)
		BB:Save()
	end
	MenuCallbackHandler.callback_doc_toggle = function(self, item)
		BB._data.doc = (item:value() == "on" and true or false)
		BB:Save()
	end
	MenuCallbackHandler.callback_dom_toggle = function(self, item)
		BB._data.dom = (item:value() == "on" and true or false)
		BB:Save()
	end
	BB:Load()
	MenuHelper:LoadFromJsonFile( BB._path .. "menu.txt", BB, BB._data )
end )

BB:Load()

function BB:add_cop_to_intimidation_list(unit_key)
	local t = TimerManager:game():time()
	local is_new = not self.cops_to_intimidate[unit_key] or t - self.cops_to_intimidate[unit_key] > self.grace_period
	self.cops_to_intimidate[unit_key] = t
	if is_new and Network:is_server() then
		local function _dont_attack(unit)
			local data = unit:brain()._logic_data
			if data.attention_obj and data.attention_obj.u_key == unit_key then
				CopLogicBase._set_attention_obj(data, nil, nil)
			end
		end
		for _, sighting in pairs(managers.groupai:state()._ai_criminals) do
			_dont_attack(sighting.unit)
		end
		for _, unit in pairs(managers.groupai:state()._converted_police) do
			_dont_attack(unit)
		end
	end
end

function BB:getNode(id)
    for name, script in pairs(managers.mission:scripts()) do
        if script:element(id) then
            return script:element(id)
        end
    end
end

function BB:executeNode(id)
    local node = BB:getNode(id)
    if node then
		node._values.enabled = true
        node._values.trigger_times = 2
    end
end

if RequiredScript == "lib/managers/group_ai_states/groupaistatebase" then
	local old_cstcc = GroupAIStateBase.chk_say_teamAI_combat_chatter
	function GroupAIStateBase:chk_say_teamAI_combat_chatter(unit)
		if BB._data.chat then
			return
		else
			old_cstcc(self, unit)
		end
	end
	local bb_original_groupaistatebase_ontasestart = GroupAIStateBase.on_tase_start
	function GroupAIStateBase:on_tase_start(cop_key, criminal_key)
		bb_original_groupaistatebase_ontasestart(self, cop_key, criminal_key)
		local bot_record = self._ai_criminals[criminal_key]
		if bot_record then
			if not self._police[cop_key].unit:contour()._contour_list then
				bot_record.unit:sound():say("f32y_any", true, false)
				self._police[cop_key].unit:contour():add("mark_enemy", true)
			end
		end
	end
end

if RequiredScript == "lib/units/player_team/logics/teamailogicassault" then
	function TeamAILogicAssault.find_enemy_to_intimidate(data)
		local targets
		if BB._data.dom then
			targets = data.detected_attention_objects
		else
			targets = {}
			for u_key, t in pairs(BB.cops_to_intimidate) do
				if data.t - t < BB.grace_period then
					targets[u_key] = data.detected_attention_objects[u_key]
				end
			end
		end
		local best_nmy, best_nmy_wgt, best_priority
		for u_key, u_char in pairs(targets) do
			if u_char.identified and u_char.verified and u_char.is_person and u_char.char_tweak and not u_char.char_tweak.is_escort and managers.groupai:state():has_room_for_police_hostage() then
				local anim_data = u_char.unit:anim_data()
				if not u_char.char_tweak.priority_shout and not anim_data.long_dis_interact_disabled and not anim_data.hands_tied and tweak_data.character[u_char.unit:base()._tweak_table].surrender then
					local u_damage = u_char.unit:character_damage()
					if u_damage and not u_damage:dead() then
						local is_hurt = u_damage:health_ratio() < 0.9
						local is_vulnerable = anim_data.hands_back or anim_data.surrender or anim_data.tased or is_hurt
						u_char.priority = anim_data.hands_back and 1 or anim_data.surrender and 2 or anim_data.tased and 3 or is_hurt and 4 or 5
						if is_vulnerable and (not best_priority or u_char.priority <= best_priority) and (not best_nmy_wgt or u_char.verified_dis < best_nmy_wgt) then
							best_nmy_wgt = u_char.verified_dis
							if best_nmy_wgt <= 1200 then
								best_nmy = u_char.unit
								best_priority = u_char.priority
							end
						end
					end
				end
			end
		end
		return best_nmy
	end
	function TeamAILogicAssault.intimidate_law_enforcement(data, criminal, intimidate_unit, play_sound, play_action)
		if intimidate_unit:anim_data().hands_back then
			act_name = "arrest"
			sound_name = "l03x_sin"
		elseif intimidate_unit:anim_data().surrender then
			act_name = "arrest"
			sound_name = "l02x_sin"
		else
			act_name = "gesture_stop"
			sound_name = "l01x_sin"
		end
		if play_sound then
			criminal:sound():say(sound_name, true, false)
		end
		if play_action and not criminal:movement():chk_action_forbidden("action") then
			local new_action = {
				type = "act",
				variant = act_name,
				body_part = 3,
				align_sync = true
			}
			if criminal:brain():action_request(new_action) then
				data.internal_data.gesture_arrest = true
			end
		end
		if intimidate_unit then
			intimidate_unit:brain():on_intimidated(tweak_data.player.long_dis_interaction.intimidate_strength, criminal)
		end
	end
	function TeamAILogicAssault.interact_check(data, my_data)
		if (not my_data.interact_t or my_data.interact_t + 2 < data.t) and not my_data.acting then
			local intimidate_unit = TeamAILogicAssault.find_enemy_to_intimidate(data)
			local civ = TeamAILogicIdle.find_civilian_to_intimidate(data.unit, 180, 1200)
			local nmy = TeamAILogicAssault.find_enemy_to_mark(data.detected_attention_objects)
			if intimidate_unit then
				my_data.interact_t = data.t
				TeamAILogicAssault.intimidate_law_enforcement(data, data.unit, intimidate_unit, true, true)
			end
			if civ then
				my_data.interact_t = data.t
				TeamAILogicIdle.intimidate_civilians(data, data.unit, true, true)
			end
			if nmy and not nmy:contour()._contour_list then
				my_data.interact_t = data.t
				TeamAILogicAssault.mark_enemy(data, data.unit, nmy, true, true)
			end
		end
	end
	function TeamAILogicAssault._upd_enemy_detection(data, is_synchronous)
		managers.groupai:state():on_unit_detection_updated(data.unit)
		data.t = TimerManager:game():time()
		local my_data = data.internal_data
		local max_reaction
		if data.cool then
			max_reaction = AIAttentionObject.REACT_SURPRISED
		end
		local delay = CopLogicBase._upd_attention_obj_detection(data, nil, max_reaction)
		local new_attention, new_prio_slot, new_reaction = TeamAILogicIdle._get_priority_attention(data, data.detected_attention_objects, nil)
		local old_att_obj = data.attention_obj
		TeamAILogicBase._set_attention_obj(data, new_attention, new_reaction)
		TeamAILogicAssault._chk_exit_attack_logic(data, new_reaction)
		if my_data ~= data.internal_data then
			return
		end
		if data.objective and data.objective.type == "follow" and TeamAILogicIdle._check_should_relocate(data, my_data, data.objective) and not data.unit:movement():chk_action_forbidden("walk") then
			data.objective.in_place = nil
			if new_prio_slot and new_prio_slot > 3 then
				data.objective.called = true
			end
			TeamAILogicBase._exit(data.unit, "travel")
			return
		end
		CopLogicAttack._upd_aim(data, my_data)
		TeamAILogicAssault.interact_check(data, my_data)
		TeamAILogicAssault._chk_request_combat_chatter(data, my_data)
		if not is_synchronous then
			CopLogicBase.queue_task(my_data, my_data.detection_task_key, TeamAILogicAssault._upd_enemy_detection, data, data.t + delay)
		end
	end
end

if RequiredScript == "lib/units/player_team/teamaidamage" then
	local bb_original_teamaidamage_applydamage = TeamAIDamage._apply_damage
	function TeamAIDamage:_apply_damage(...)
		local damage_percent, health_subtracted = bb_original_teamaidamage_applydamage(self, ...)
		if not self.bb_said_hurt and self._health_ratio <= 0.2 and BB._data.doc and not self:_cannot_take_damage() then
			self.bb_said_hurt = true
			self._unit:sound():say("g80x_plu", true, true)
		end
		return damage_percent, health_subtracted
	end
	local bb_original_teamaidamage_regenerated = TeamAIDamage._regenerated
	function TeamAIDamage:_regenerated()
		bb_original_teamaidamage_regenerated(self)
		self.bb_said_hurt = false
	end
end

if RequiredScript == "lib/units/enemies/cop/copdamage" then
	local bb_original_copdamage_damagemelee = CopDamage.damage_melee
	function CopDamage:damage_melee(attack_data)
		if attack_data.variant == "taser_tased" then
			BB:add_cop_to_intimidation_list(self._unit:key())
		end
		return bb_original_copdamage_damagemelee(self, attack_data)
	end
	local bb_original_copdamage_syncdamagemelee = CopDamage.sync_damage_melee
	function CopDamage:sync_damage_melee(attacker_unit, damage_percent, damage_effect_percent, i_body, hit_offset_height, variant, death)
		if variant == 5 then
			BB:add_cop_to_intimidation_list(self._unit:key())
		end
		return bb_original_copdamage_syncdamagemelee(self, attacker_unit, damage_percent, damage_effect_percent, i_body, hit_offset_height, variant, death)
	end
end

if RequiredScript == "lib/managers/criminalsmanager" then
	if not BigLobbyGlobals then
		CriminalsManager.MAX_NR_TEAM_AI = BB._data.number or 2
	end
	if NoobJoin then
		local old_create = CriminalsManager._create_characters
		function CriminalsManager:_create_characters()
			old_create(self)
			for character, data in pairs(self._characters) do
				data.static_data.ai_mask_id = "baby_cry"
			end
		end
	end
	local bbots = {}
	bbots.health = {nil,75,24,34,61.2,102}
	bbots.weaprof = {nil,"normal","good","expert","deathwish"}
	bbots.speed = {"very_slow","slow","normal","fast","very_fast","lightning"}
	bbots.dodge = {"poor","average","heavy","athletic","ninja"}
	health_bot = bbots.health[BB._data.health or 1]
	weaprof_bot = bbots.weaprof[BB._data.weaprof or 1]
	speed_bot = bbots.speed[BB._data.speed or 4]
	dodge_bot = bbots.dodge[BB._data.dodge or 4]
	if health_bot then
		tweak_data.character.presets.gang_member_damage.HEALTH_INIT = health_bot
	end
	if BB._data.mindmg then
		tweak_data.character.presets.gang_member_damage.MIN_DAMAGE_INTERVAL = tweak_data.player.damage.MIN_DAMAGE_INTERVAL
	end
	if BB._data.instadwn and (Global.game_settings.permission ~= "public" or Global.game_settings.single_player) then
		tweak_data.character.presets.gang_member_damage.DOWNED_TIME = 0
	end
	if weaprof_bot and BB._data.weap ~= 3 then
		tweak_data.character.presets.weapon.gang_member.m4.spread = tweak_data.character.presets.weapon[weaprof_bot].m4.spread
		tweak_data.character.presets.weapon.gang_member.m4.FALLOFF = tweak_data.character.presets.weapon[weaprof_bot].m4.FALLOFF
	end
	tweak_data.character.presets.weapon.gang_member.m4.aim_delay = { 0, 0 }
	tweak_data.character.presets.weapon.gang_member.m4.focus_delay = 0
	tweak_data.character.presets.weapon.gang_member.m4.range = tweak_data.character.presets.weapon.sniper.m4.range
	for k, v in pairs(tweak_data.character) do
		if type(v) == "table" and v.access == "teamAI1" then
			v.no_run_start = true
			v.no_run_stop = true
			v.always_face_enemy = true
			v.move_speed = tweak_data.character.presets.move_speed[speed_bot]
			v.damage.hurt_severity = tweak_data.character.presets.hurt_severities.only_light_hurt
			if BB._data.move == 2 then
				v.allowed_poses = { stand = true }
				v.dodge = tweak_data.character.presets.dodge[dodge_bot]
			elseif BB._data.move == 3 then
				v.allowed_poses = { stand = true }
			end
			local orig = v.weapon.weapons_of_choice
			v.weapon = deep_clone(tweak_data.character.presets.weapon.gang_member)
			v.weapon.weapons_of_choice = orig
			if BB._data.weap == 2 then
				v.weapon.weapons_of_choice = { primary = Idstring("units/payday2/weapons/wpn_npc_ak47/wpn_npc_ak47") }
			elseif BB._data.weap == 3 then
				v.weapon.weapons_of_choice = { primary = Idstring("units/payday2/weapons/wpn_npc_mp5/wpn_npc_mp5") }
				v.weapon.mp5.spread = 0
				v.weapon.mp5.FALLOFF[1].dmg_mul = 5
				v.weapon.mp5.FALLOFF[2].dmg_mul = 5
				v.weapon.mp5.FALLOFF[3].dmg_mul = 5
			end
		end
	end
end

if RequiredScript == "lib/units/player_team/teamaimovement" then
	function TeamAIMovement:on_SPOOCed(enemy_unit)
		if BB._data.clkarrest and (Global.game_settings.permission ~= "public" or Global.game_settings.single_player) then
			self._unit:brain():set_logic("surrender")
			self._unit:network():send("arrested")
			self._unit:character_damage():on_arrested()
		else
			self._unit:character_damage():on_incapacitated()
		end
	end
	if not BotWeapons then
		function TeamAIMovement:check_visual_equipment()
			local flags = { 
				{ g_vest_small = true, g_ammobag = true },
				{ g_vest_small = true, g_medicbag = true }
			}
			local equipment = math.random(#flags)
			for k, v in pairs(flags[equipment]) do
				local mesh_name = Idstring(k)
				local mesh_obj = self._unit:get_object(mesh_name)
				if mesh_obj then
					mesh_obj:set_visibility(v)
				end
			end
		end
	end
end

if RequiredScript == "lib/units/player_team/logics/teamailogicidle" then
	local old_enter = TeamAILogicIdle.enter
	function TeamAILogicIdle.enter(data, new_logic_name, enter_params)
		old_enter(data, new_logic_name, enter_params)
		local my_data = data.internal_data
		if not my_data.acting and not managers.groupai:state():whisper_mode() then
			local weapon_base = data.unit:inventory():equipped_unit():base()
			if weapon_base:get_ammo_remaining_in_clip() < weapon_base:get_ammo_max_per_clip() then
				data.unit:movement():play_redirect("reload")
				weapon_base:on_reload()
				weapon_base:stop_autofire()
			end
		end
	end
	function TeamAILogicIdle._upd_enemy_detection(data)
		managers.groupai:state():on_unit_detection_updated(data.unit)
		data.t = TimerManager:game():time()
		local my_data = data.internal_data
		local max_reaction
		if data.cool then
			max_reaction = AIAttentionObject.REACT_SURPRISED
		end
		local delay = CopLogicBase._upd_attention_obj_detection(data, nil, max_reaction)
		local new_attention, new_prio_slot, new_reaction = TeamAILogicIdle._get_priority_attention(data, data.detected_attention_objects, nil)
		TeamAILogicAssault.interact_check(data, my_data)
		TeamAILogicBase._set_attention_obj(data, new_attention, new_reaction)
		if new_reaction and new_reaction >= AIAttentionObject.REACT_SCARED then
			local objective = data.objective
			local wanted_state
			local allow_trans, obj_failed = CopLogicBase.is_obstructed(data, objective, nil, new_attention)
			if allow_trans then
				wanted_state = TeamAILogicBase._get_logic_state_from_reaction(data, new_reaction)
				local objective = data.objective
				if objective and objective.type == "revive" then
					local revive_unit = objective.follow_unit
					local timer
					if revive_unit:base().is_local_player then
						timer = revive_unit:character_damage()._downed_timer
					elseif revive_unit:interaction().get_waypoint_time then
						timer = revive_unit:interaction():get_waypoint_time()
					end
					if timer and timer <= 10 then
						wanted_state = nil
					end
				end
			end
			if wanted_state and wanted_state ~= data.name then
				if obj_failed then
					data.objective_failed_clbk(data.unit, data.objective)
				end
				if my_data == data.internal_data then
					CopLogicBase._exit(data.unit, wanted_state)
				end
				return
			end
		end
		data.logic._upd_sneak_spotting(data, my_data)
		CopLogicBase.queue_task(my_data, my_data.detection_task_key, TeamAILogicIdle._upd_enemy_detection, data, data.t + delay)
	end
	function TeamAILogicIdle._get_priority_attention(data, attention_objects, reaction_func)
		reaction_func = reaction_func or TeamAILogicBase._chk_reaction_to_attention_object
		local best_target, best_target_priority_slot, best_target_priority, best_target_reaction
		local not_coplogicattack_can_move = not CopLogicAttack._can_move(data)
		local cops_to_intimidate = BB.cops_to_intimidate
		for u_key, attention_data in pairs(attention_objects) do
			if not attention_data.identified then
			elseif attention_data.pause_expire_t then
				if data.t > attention_data.pause_expire_t then
					attention_data.pause_expire_t = nil
				end
			elseif attention_data.stare_expire_t and data.t > attention_data.stare_expire_t then
				if attention_data.settings.pause then
					attention_data.stare_expire_t = nil
					attention_data.pause_expire_t = data.t + math.lerp(attention_data.settings.pause[1], attention_data.settings.pause[2], math.random())
				end
			else
				local distance = attention_data.dis
				local reaction = reaction_func(data, attention_data, not_coplogicattack_can_move)
				local reaction_too_mild
				if not reaction or best_target_reaction and best_target_reaction > reaction then
					reaction_too_mild = true
				elseif reaction <= AIAttentionObject.REACT_SURPRISED then
					reaction_too_mild = true
				end
				if not reaction_too_mild then
					local alert_dt = attention_data.alert_t and data.t - attention_data.alert_t or 10000
					local dmg_dt = attention_data.dmg_t and data.t - attention_data.dmg_t or 10000
					local mark_dt = attention_data.mark_t and data.t - attention_data.mark_t or 10000
					if data.attention_obj and data.attention_obj.u_key == u_key then
						alert_dt = alert_dt * 0.8
						dmg_dt = dmg_dt * 0.8
						mark_dt = mark_dt * 0.8
						distance = distance * 0.8
					end
					local visible = attention_data.verified
					local has_alerted = alert_dt < 5
					local has_damaged = dmg_dt < 2
					local been_marked = mark_dt < 8
					local target_priority = distance
					local target_priority_slot = 0
					local shielded_special = attention_data.is_shield
					local att_unit = attention_data.unit
					local enemy_type = att_unit:base()._tweak_table
					if visible then
						target_priority_slot = 1 + math.floor(distance/200)
						if enemy_type == "spooc" then
							target_priority_slot = target_priority_slot - 5
						elseif enemy_type == "taser" then
							target_priority_slot = target_priority_slot - 4
						elseif enemy_type == "tank" then
							target_priority_slot = target_priority_slot - 3
						elseif enemy_type == "sniper" then
							target_priority_slot = target_priority_slot - 2
						elseif enemy_type == "fbi" then
							target_priority_slot = target_priority_slot - 1
						elseif shielded_special then
							local target_vec = data.m_pos - att_unit:movement():m_pos()
							local spin = target_vec:to_polar_with_reference(att_unit:movement():m_rot():y(), math.UP).spin
							if math.abs(spin) < 60 then
								target_priority_slot = target_priority_slot + 5
							end
						end
						if has_alerted and has_damaged then
							target_priority_slot = target_priority_slot - 2
						elseif has_alerted then
							target_priority_slot = target_priority_slot - 1
						elseif has_damaged then
							target_priority_slot = target_priority_slot - 1
						end
						if been_marked then
							target_priority_slot = target_priority_slot - 1
						end
						target_priority_slot = math.clamp(target_priority_slot, 1, 20)
					else
						reaction = math.min(reaction, AIAttentionObject.REACT_AIM)
					end
					if reaction < AIAttentionObject.REACT_COMBAT then
						target_priority_slot = 20 + target_priority_slot + math.max(0, AIAttentionObject.REACT_COMBAT - reaction)
					end
					if target_priority_slot > 0 then
						local best = false
						if not best_target then
							best = true
						elseif best_target_priority_slot > target_priority_slot then
							best = true
						elseif target_priority_slot == best_target_priority_slot and best_target_priority > target_priority then
							best = true
						end
						if best and not (cops_to_intimidate[u_key] and data.t - cops_to_intimidate[u_key] < BB.grace_period) then
							best_target = attention_data
							best_target_priority_slot = target_priority_slot
							best_target_priority = target_priority
							best_target_reaction = reaction
						end
					end
				end
			end
		end
		return best_target, best_target_priority_slot, best_target_reaction
	end
	function TeamAILogicIdle._find_intimidateable_civilians(criminal, use_default_shout_shape, max_angle, max_dis)
		local head_pos = criminal:movement():m_head_pos()
		local look_vec = criminal:movement():m_rot():y()
		local close_dis = 400
		local intimidateable_civilians = {}
		local best_civ
		local best_civ_wgt = false
		local best_civ_angle
		local highest_wgt = 1
		local my_tracker = criminal:movement():nav_tracker()
		local chk_vis_func = my_tracker.check_visibility
		for key, u_data in pairs(managers.enemy:all_civilians()) do
			local unit = u_data.unit
			if chk_vis_func(my_tracker, unit:movement():nav_tracker()) and not unit:movement():cool() and tweak_data.character[unit:base()._tweak_table].intimidateable and not unit:base().unintimidateable and not unit:anim_data().unintimidateable and not unit:anim_data().drop and not unit:brain():is_tied() and not unit:unit_data().disable_shout then
				local u_head_pos = unit:movement():m_head_pos() + math.UP * 30
				local vec = u_head_pos - head_pos
				local dis = mvector3.normalize(vec)
				local angle = vec:angle(look_vec)
				if use_default_shout_shape then
					max_angle = math.max(8, math.lerp(90, 30, dis / 1200))
					max_dis = 1200
				end
				if close_dis > dis or dis < max_dis and angle < max_angle then
					local slotmask = managers.slot:get_mask("AI_visibility")
					local ray = World:raycast("ray", head_pos, u_head_pos, "slot_mask", slotmask, "ray_type", "ai_vision")
					if not ray then
						local inv_wgt = dis * dis * (1 - vec:dot(look_vec))
						table.insert(intimidateable_civilians, {
							unit = unit,
							key = key,
							inv_wgt = inv_wgt
						})
						if not best_civ_wgt or best_civ_wgt > inv_wgt then
							best_civ_wgt = inv_wgt
							best_civ = unit
							best_civ_angle = angle
						end
						if highest_wgt < inv_wgt then
							highest_wgt = inv_wgt
						end
					end
				end
			end
		end
		return best_civ, highest_wgt, intimidateable_civilians
	end
	function TeamAILogicIdle.on_alert(data, alert_data)
		local alert_type = alert_data[1]
		local alert_unit = alert_data[5]
		if alert_unit:in_slot(data.enemy_slotmask) then
			local att_obj_data, is_new = CopLogicBase.identify_attention_obj_instant(data, alert_unit:key())
			if att_obj_data and (alert_type == "bullet" or alert_type == "aggression" or alert_type == "explosion") then
				att_obj_data.alert_t = TimerManager:game():time()
			end
		end
		if CopLogicBase.is_alert_dangerous(alert_type) then
			data.unit:movement():set_cool(false)
		end
	end
end

if RequiredScript == "lib/units/enemies/cop/logics/coplogicidle" then
	function CopLogicIdle.on_intimidated(data, amount, aggressor_unit)
		local surrender = false
		local my_data = data.internal_data
		data.t = TimerManager:game():time()
		if not aggressor_unit:movement():team().foes[data.unit:movement():team().id] then
			return
		end
		if managers.groupai:state():has_room_for_police_hostage() then
			local i_am_special = managers.groupai:state():is_enemy_special(data.unit)
			local required_skill = i_am_special and "intimidate_specials" or "intimidate_enemies"
			local record = managers.groupai:state():all_criminals()[aggressor_unit:key()]
			local aggressor_can_intimidate
			local aggressor_intimidation_mul = 1
			if aggressor_unit:base().is_local_player or record.ai then
				aggressor_can_intimidate = managers.player:has_category_upgrade("player", required_skill)
				aggressor_intimidation_mul = aggressor_intimidation_mul * managers.player:upgrade_value("player", "empowered_intimidation_mul", 1) * managers.player:upgrade_value("player", "intimidation_multiplier", 1)
			else
				aggressor_can_intimidate = aggressor_unit:base():upgrade_value("player", required_skill)
				aggressor_intimidation_mul = aggressor_intimidation_mul * (aggressor_unit:base():upgrade_value("player", "empowered_intimidation_mul") or 1) * (aggressor_unit:base():upgrade_value("player", "intimidation_multiplier") or 1)
			end
			--print("aggressor_can_intimidate", aggressor_can_intimidate, "required_skill", required_skill, "is_local_player", aggressor_unit:base().is_local_player)
			if aggressor_can_intimidate then
				local hold_chance = CopLogicBase._evaluate_reason_to_surrender(data, my_data, aggressor_unit)
				--print("hold_chance", hold_chance)
				if hold_chance then
					hold_chance = hold_chance ^ aggressor_intimidation_mul
					if hold_chance >= 1 then
					else
						local rand_nr = math.random()
						--print("and the winner is: hold_chance", hold_chance, "rand_nr", rand_nr, "rand_nr > hold_chance", hold_chance < rand_nr)
						if hold_chance < rand_nr then
							surrender = true
						end
					end
				end
			end
			if surrender then
				CopLogicIdle._surrender(data, amount, aggressor_unit)
			else
				data.unit:brain():on_surrender_chance()
			end
			if (aggressor_unit:base().is_local_player or aggressor_unit:base().is_husk_player) or surrender then
				BB:add_cop_to_intimidation_list(data.unit:key())
			end
		end
		CopLogicBase.identify_attention_obj_instant(data, aggressor_unit:key())
		managers.groupai:state():criminal_spotted(aggressor_unit)
		return surrender
	end
end

if RequiredScript == "lib/managers/mission/elementmissionend" then
	function ElementMissionEnd:on_executed(instigator)
		if not self._values.enabled then
			return
		end
		if self._values.state ~= "none" and managers.platform:presence() == "Playing" then
			if self._values.state == "success" then
				local num_winners = managers.network:session():amount_of_alive_players()
				if Global.game_settings.single_player then
					num_winners = managers.network:session():amount_of_alive_players() + managers.groupai:state():amount_of_winning_ai_criminals()
				end
				managers.network:session():send_to_peers("mission_ended", true, num_winners)
				game_state_machine:change_state_by_name("victoryscreen", {
					num_winners = num_winners,
					personal_win = alive(managers.player:player_unit())
				})
			elseif self._values.state == "failed" then
				print("No fail state yet")
			elseif self._values.state == "leave" then
				MenuCallbackHandler:leave_mission()
			elseif self._values.state == "leave_safehouse" then
				MenuCallbackHandler:leave_safehouse()
			end
		elseif Application:editor() then
			managers.editor:output_error("Cant change to state " .. self._values.state .. " in mission end element " .. self._editor_name .. ".")
		end
		ElementMissionEnd.super.on_executed(self, instigator)
	end
end

if RequiredScript == "lib/managers/dialogmanager" then
	local old_manager = DialogManager.queue_dialog
	function DialogManager:queue_dialog(id, params)
		old_manager(self, id, params)
		if id == "Play_loc_jr2_09" then
			BB:executeNode(101020)
			BB:executeNode(101021)
		end
	end
end